//
//  AmpDownload.swift
//  AmpDownloader
//
//  Created by Miguel Hernandez on 1/18/19.
//  Copyright © 2019 Miguel Hernandez. All rights reserved.
//

import AVKit

@objc public class AmpDownload: NSObject, Codable , AVAssetDownloadDelegate {
    
    var _id:String
    
    var _title:String
    
    var _isCompleted:Bool = false
    
    var _isFailed:Bool = false
    
    var _isPaused:Bool = false
    
    var _isCanceled:Bool = false
    
    var _url:String
    
    var _location:URL?
    
    var _progress:Float?
    
    var _assetArtworkData:Data?
    
    // Flag for issues on iOS 11
    var _cancelDownload = false
    
    private enum CodingKeys: String, CodingKey {
        case _id = "id"
        case _title = "title"
        case _isCompleted = "completed"
        case _isFailed = "failed"
        case _isPaused = "paused"
        case _isCanceled = "canceled"
        case _url = "url"
        case _location = "fileLocation"
        case _assetArtworkData = "artwork"
    }
    
    public init(title:String, url:String, assetArtworkData:Data? = nil) {
        _id = UUID().uuidString
        _title = title
        _assetArtworkData = assetArtworkData
        _url = url
        super.init()
    }
    
//    init(id:String, title:String, progress:Float, isCompleted:Bool) {
//        _id = id
//        _title = title
//        _isCompleted = isCompleted
//        _isPaused = true
//        super.init()
//    }
//    
//    init(title:String) {
//        _id = ""
//        _title = title
//        _isCompleted = false
//        _isPaused = false
//        super.init()
//    }
    
    func deleteDownload() {
        if let location = _location {
            do {
                try FileManager.default.removeItem(at: location)
                _location = nil
                AmpDownloadManager.notifyDownloadDeleted(asset: self)
            } catch {
                // todo:log
            }
        }
    }
    
    static func ==(lhs: AmpDownload, rhs: AmpDownload) -> Bool {
        return (lhs._id == rhs._id)
    }
    
}
