//
//  AmpDownloadClient.swift
//  AmpDownloader
//
//  Created by Miguel Hernandez on 1/18/19.
//  Copyright © 2019 Miguel Hernandez. All rights reserved.
//

import AVKit

extension AmpDownload {
    
    public var id:String {
        get {
            return _id
        }
    }
    
    public var title:String {
        get {
            return _title
        }
    }
    
    public var isCompleted: Bool {
        get {
            return _isCompleted
        }
    }
    
    public var isPaused: Bool {
        get {
            return _isPaused
        }
    }
    
    public var isCanceled: Bool {
        get {
            return _isCanceled
        }
    }
    
    public var originUrl:String {
        get {
            return _url
        }
    }
    
    public var assetLocation:URL? {
        get {
            return _location
        }
    }
    
    public var asset:AVURLAsset? {
        get {
            return AVURLAsset(url: URL(string: _url)!)
        }
    }
    
    public var progress:Float? {
        get {
            if _isCompleted {
                return 1.0
            }
            return _progress
        }
    }
    
    public func deleteVideo() {
        let _ = AmpWritter.deleteDownload(download: self)
    }
}
