//
//  AmpDownloadManager.swift
//  AmpDownloader
//
//  Created by Miguel Hernandez on 1/18/19.
//  Copyright © 2019 Miguel Hernandez. All rights reserved.
//

import Foundation

public class AmpDownloadManager {
    
    static let instance = AmpDownloadManager()
    
    var delegates:[AmpDownloaderDelegate] = []
    
    private init () {
    }
    
    static func notifyDownloadStart(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadStarted?(asset: asset)})
    }
    
    static func notifyDownloadPause(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadPaused?(asset: asset)})
    }
    
    static func notifyDownloadResume(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadResumed?(asset: asset)})
    }
    
    static func notifyDownloadCompleted(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadCompleted?(asset: asset)})
    }
    
    static func notifyDownloadCancelled(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadCancelled?(asset: asset)})
    }
    
    static func notifyStateChanged(asset: AmpDownload, mediaOption:String) {
        instance.delegates.forEach({$0.downloadStateChanged?(asset: asset, mediaOption: mediaOption)})
    }
    
    static func notifyDownloadDeleted(asset: AmpDownload) {
        instance.delegates.forEach({$0.downloadDeleted?(asset: asset)})
        
    }
    
    static func notifyDownloadProgressChange(asset: AmpDownload, progress:Float) {
        instance.delegates.forEach({$0.downloadProgressChanged?(asset: asset, progress: progress)})
    }
    
    static func notifyDownloadError(asset:AmpDownload, error:NSError, message:String) {
        instance.delegates.forEach({$0.downloadFailed?(asset: asset, error: error, message: message)})
    }
    
}
