//
//  AmpDownloadManagerClient.swift
//  AmpDownloader
//
//  Created by Miguel Hernandez on 1/18/19.
//  Copyright © 2019 Miguel Hernandez. All rights reserved.
//

import Foundation

@available(iOS 11.0, *)
extension AmpDownloadManager {
    
    public static func registerDelegate(delegate:AmpDownloaderDelegate) {
        let isContained = instance.delegates.contains { element in
            if delegate === element {
                return true
            } else {
                return false
            }
        }
        
        if !isContained {
            instance.delegates.append(delegate)
        }
    }
    
    public static func removeDelegate(delegate:AmpDownloaderDelegate) {
        for (index, item) in instance.delegates.enumerated() {
            if delegate === item {
                instance.delegates.remove(at: index)
                break
            }
        }
    }
    
    public static func getDownloadList() -> [AmpDownload] {
        return AmpWritter.getDownloadData(forceUpdate: true)
    }
    
    public static func startNewDownload(title:String, url:String, assetArtworkData:Data? = nil) -> AmpDownload? {
        
        guard let downloadObject = AmpAssetDatabaseManager.sharedManager.downloadAsset(url: url, title: title, assetArtworkData: assetArtworkData) else {
            return nil
        }
        
        return downloadObject
    }
    
    public static func resumeDownload(for asset:AmpDownload) {
        AmpAssetDatabaseManager.sharedManager.resumeDownload(for: asset)
    }
    
    public static func pauseDownload(for asset:AmpDownload) {
        AmpAssetDatabaseManager.sharedManager.pauseDownload(for: asset)
    }
    
    public static func deleteDownload(for asset:AmpDownload) {
        AmpAssetDatabaseManager.sharedManager.deleteAsset(asset)
    }
    
    public static func cancelDownload(for asset:AmpDownload) {
        AmpAssetDatabaseManager.sharedManager.cancelDownload(for: asset)
    }
    
    public static func restoreDownloads() {
        AmpAssetDatabaseManager.sharedManager.restoreManager()
    }
}
