//
//  AmpDownloadDelegate.swift
//  AmpDownloader
//
//  Created by Miguel Hernandez on 1/18/19.
//  Copyright © 2019 Miguel Hernandez. All rights reserved.
//

import Foundation

@objc public protocol AmpDownloaderDelegate: class {
    
    @objc optional func downloadStarted(asset: AmpDownload)
    
    @objc optional func downloadPaused(asset:AmpDownload)
    
    @objc optional func downloadResumed(asset:AmpDownload)
    
    @objc optional func downloadCompleted(asset: AmpDownload)
    
    @objc optional func downloadCancelled(asset: AmpDownload)
    
    @objc optional func downloadDeleted(asset: AmpDownload)
    
    @objc optional func downloadProgressChanged(asset: AmpDownload, progress:Float)
    
    @objc optional func downloadStateChanged(asset: AmpDownload, mediaOption:String)
    
    @objc optional func downloadFailed(asset: AmpDownload, error: NSError, message: String)
}
