//
//  DownloadController.swift
//  AmpSimpleSample
//
//  Created by Miguel Hernandez on 1/9/19.
//  Copyright © 2023 Akamai. All rights reserved.
//

import UIKit
import AmpDownloader

protocol DownloadObserver {
    func downloadStarted()
    
    func downloadProgressChanged()
    
    
}

class DownloadController: UIViewController {
    
    @IBOutlet weak var progressBar: UIProgressView!
    
    @IBOutlet weak var urlField: UITextField!
    
    @IBAction func startDownload(_ sender: Any) {
//        insertDownload(download:AmpDownload(title: "asdf", url: ";lkj"))
        if let url = urlField.text {
            let download = AmpDownloadManager.startNewDownload(title: "stuff \(AmpDownloadManager.getDownloadList().count)", url: url)
            print("New download \(download?.id), \(download?.isPaused)")
        }
        
    }
    
    @IBAction func levelup(_ sender: Any) {
        for d in getDownloads() {
            print("Download \(d.id), \(d.isPaused)")
        }
    }
    
    let path:String = {
        let documentDirectory = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0] as String
        return documentDirectory.appending("/AmpDownloads.plist")
    }()
    
    func getDownloads() -> [AmpDownload] {
        var array:[AmpDownload] = []
        if let data = FileManager.default.contents(atPath: path),
            let decodedArray = try? PropertyListDecoder().decode(Array<AmpDownload>.self, from: data) {
            array = decodedArray
        } else {
            array = []
        }
        return array
    }
    
}
