//
//  man.swift
//  AmpSimpleSample
//
//  Created by Miguel Hernandez on 1/25/19.
//  Copyright © 2019 Akamai. All rights reserved.
//

import Foundation
import AVKit

//extension AmpDownload:AVAssetDownloadDelegate {
//    
//    
//    public func urlSession(_ session: URLSession, assetDownloadTask: AVAssetDownloadTask, didLoad timeRange: CMTimeRange, totalTimeRangesLoaded loadedTimeRanges: [NSValue], timeRangeExpectedToLoad: CMTimeRange) {
//        if _isPaused && _downloadTask?.state == .running {
//            _isPaused = false
//            AmpDownloadManager.notifyDownloadResume(asset: self)
//        }
//
//        var progress = 0.0
//        for value in loadedTimeRanges {
//            let loadedTimeRange = value.timeRangeValue
//            progress += loadedTimeRange.duration.seconds / timeRangeExpectedToLoad.duration.seconds
//        }
//        _progress = Float(progress)
//        AmpDownloadManager.notifyDownloadProgressChange(asset: self, progress: _progress!)
//
//        if _downloadTask?.state == .suspended && !_isPaused {
//            _isPaused = true
//            AmpDownloadManager.notifyDownloadPause(asset: self)
//        }
//    }
//
//    public func urlSession(_ session: URLSession, assetDownloadTask: AVAssetDownloadTask, didFinishDownloadingTo location: URL) {
//
//        _isCompleted = true
//        _location = location
//
//        // TODO: _downloadTask?.state == .canceling would work but has issues on iOS 11
//        if _cancelDownload {
//            AmpDownloadManager.notifyDownloadCancelled(asset: self)
//            deleteVideo()
//        } else {
//            if _isPaused {
//                _isPaused = false
//            }
//            AmpDownloadManager.notifyDownloadCompleted(asset: self)
//        }
//    }
//}
//
//@objc public class AmpDownload: NSObject {
//    
//    var _id:String
//    
//    var _title:String
//    
//    var _isCompleted:Bool
//    
//    var _isPaused:Bool
//    
//    var _location:URL?
//    
//    var _progress:Float?
//    
//    var _downloadTask:AVAssetDownloadTask?
//    
//    var _downloadSession:AVAssetDownloadURLSession?
//    
//    // Flag for issues on iOS 11
//    var _cancelDownload = false
//    
//    init(title:String, url:String) {
//        _id = UUID().uuidString
//        _title = title
//        _isCompleted = false
//        _isPaused = false
//        super.init()
//        startDownload(id: id, title: title, url: url)
//    }
//    
//    func startDownload(id:String, title:String, url:String) {
//        guard let url = URL(string: url) else {
//            print("error in url")
//            return
//        }
//        
//        _downloadSession = getDownloadSession(id: id)
//        
//        downloadAsset(url: url, title: title)
//        
//    }
//    
//    private func getDownloadSession(id: String) -> AVAssetDownloadURLSession {
//        // Create new background session configuration.
//        let configuration = URLSessionConfiguration.background(withIdentifier: id)
//        
//        // Create a new AVAssetDownloadURLSession with background configuration, delegate, and queue
//        return AVAssetDownloadURLSession(configuration: configuration,
//                                         assetDownloadDelegate: self,
//                                         delegateQueue: OperationQueue.main)
//    }
//    
//    private func downloadAsset(url:URL, title:String) {
//        guard let session = _downloadSession else {
//            return
//        }
//        
//        let assetUrl = AVURLAsset(url: url)
//        
//        _downloadTask = session.makeAssetDownloadTask(asset: assetUrl,
//                                                      assetTitle: title,
//                                                      assetArtworkData: nil,
//                                                      options: nil)
//        print("MIGUEL \(_downloadTask == nil)")
//        _downloadTask?.resume()
//        AmpDownloadManager.notifyDownloadStart(asset: self)
//        
//    }
//    
//}
//
//extension AmpDownload {
//    
//    public var id:String {
//        get {
//            return _id
//        }
//    }
//    
//    public var title:String {
//        get {
//            return _title
//        }
//    }
//    
//    public var isCompleted: Bool {
//        get {
//            return _isCompleted
//        }
//    }
//    
//    public var isPaused: Bool {
//        get {
//            return _isPaused
//        }
//    }
//    
//    public var playerItem:AVPlayerItem? {
//        if _isCompleted {
//            guard let location = _location else {
//                // todo: log
//                return nil
//            }
//            
//            let asset = AVURLAsset(url: location)
//            return AVPlayerItem(asset: asset)
//        } else {
//            guard let asset = _downloadTask?.urlAsset else {
//                // todo: log
//                return nil
//            }
//            
//            return AVPlayerItem(asset: asset)
//        }
//    }
//    
//    @available(iOS 11.0, *)
//    public var eta:TimeInterval? {
//        get {
//            return _downloadTask?.progress.estimatedTimeRemaining
//        }
//    }
//    
//    public var progress:Float? {
//        get {
//            if _isCompleted {
//                return 1.0
//            }
//            return _progress
//        }
//    }
//    
//    public func pauseDownload() {
//        if !_isCompleted {
//            _downloadTask?.suspend()
//        }
//    }
//    
//    public func resumeDownload() {
//        if !_isCompleted && _isPaused {
//            _downloadTask?.resume()
//        }
//    }
//    
//    public func cancelDownload() {
//        guard !_isCompleted else {
//            return
//        }
//        
//        _cancelDownload = true
//        _downloadTask?.cancel()
//    }
//    
//    public func deleteVideo() {
//        guard _isCompleted else {
//            return
//        }
//        
//        guard let location = _location else {
//            // todo:log
//            return
//        }
//        
//        do {
//            try FileManager.default.removeItem(at: location)
//            AmpDownloadManager.notifyDownloadDeleted(asset: self)
//        } catch {
//            // todo:log
//        }
//    }
//}
//
//
//@objc public protocol AmpDownloaderDelegate: class {
//    
//    @objc optional func downloadStarted(asset: AmpDownload)
//    
//    @objc optional func downloadPaused(asset:AmpDownload)
//    
//    @objc optional func downloadResumed(asset:AmpDownload)
//    
//    @objc optional func downloadCompleted(asset: AmpDownload)
//    
//    @objc optional func downloadCancelled(asset: AmpDownload)
//    
//    @objc optional func downloadDeleted(asset: AmpDownload)
//    
//    @objc optional func downloadProgressChanged(asset: AmpDownload, progress:Float)
//    
//}
//
//public class AmpDownloadManager {
//    
//    static let instance = AmpDownloadManager()
//    
//    var delegates:[AmpDownloaderDelegate] = []
//    
//    var _downloadList:[AmpDownload] = []
//    
//    private init () {
//    }
//    
//    static func notifyDownloadStart(asset: AmpDownload) {
//        instance.delegates.forEach({$0.downloadStarted?(asset: asset)})
//    }
//    
//    static func notifyDownloadPause(asset: AmpDownload) {
//        instance.delegates.forEach({$0.downloadPaused?(asset: asset)})
//    }
//    
//    static func notifyDownloadResume(asset: AmpDownload) {
//        instance.delegates.forEach({$0.downloadResumed?(asset: asset)})
//    }
//    
//    static func notifyDownloadCompleted(asset: AmpDownload) {
//        instance.delegates.forEach({$0.downloadCompleted?(asset: asset)})
//    }
//    
//    static func notifyDownloadCancelled(asset: AmpDownload) {
//        instance.delegates.forEach({$0.downloadCancelled?(asset: asset)})
//    }
//    
//    static func notifyDownloadDeleted(asset: AmpDownload) {
//        for (index, element) in instance._downloadList.enumerated() {
//            if (element.id == asset.id) {
//                instance._downloadList.remove(at: index)
//                break
//            }
//        }
//        instance.delegates.forEach({$0.downloadDeleted?(asset: asset)})
//        
//    }
//    
//    static func notifyDownloadProgressChange(asset: AmpDownload, progress:Float) {
//        instance.delegates.forEach({$0.downloadProgressChanged?(asset: asset, progress: progress)})
//    }
//    
//}
//
//extension AmpDownloadManager {
//    
//    public static func registerDelegate(delegate:AmpDownloaderDelegate) {
//        let isContained = instance.delegates.contains { element in
//            if delegate === element {
//                return true
//            } else {
//                return false
//            }
//        }
//        
//        if !isContained {
//            instance.delegates.append(delegate)
//        }
//    }
//    
//    public static func removeDelegate(delegate:AmpDownloaderDelegate) {
//        for (index, item) in instance.delegates.enumerated() {
//            if delegate === item {
//                instance.delegates.remove(at: index)
//                break
//            }
//        }
//    }
//    
//    public static func getDownloadList() -> [AmpDownload] {
//        return instance._downloadList
//    }
//    
//    public static func startNewDownload(title:String, url:String) -> AmpDownload {
//        let download = AmpDownload(title: title, url: url)
//        instance._downloadList.append(download)
//        return download
//    }
//}
